import { IFrameMainTransportOptions, IFrameTransportInternalOptions, ElectronMainTransportOptions, ElectronRendererTransportOptions, ServiceWorkerClientTransportOptions, ServiceWorkerServiceTransportOptions, WorkerMainTransportOptions, WorkerInternalTransportOptions, WebRTCTransport, WebRTCTransportOptions, BroadcastTransport, BroadcastTransportOptions, BrowserExtensionsMainTransport, BrowserExtensionsMainTransportOptions, BrowserExtensionsClientTransport, BrowserExtensionsClientTransportOptions, BrowserExtensionsGenericTransport, BrowserExtensionsGenericTransportOptions, SharedWorkerInternalTransportOptions, SharedWorkerClientTransportOptions, MessageTransport, MessageTransportOptions, IFrameMainTransport, IFrameInternalTransport, ElectronMainTransport, ElectronRendererTransport, ServiceWorkerClientTransport, ServiceWorkerServiceTransport, WorkerInternalTransport, WorkerMainTransport, SharedWorkerClientTransport, SharedWorkerInternalTransport, MainProcessTransport, ChildProcessTransport, MainProcessTransportOptions, ChildProcessTransportOptions } from './transports';
import { Transport } from './transport';
import type { TransportOptions } from './interface';
interface TransportOptionsMap {
    IFrameMain: IFrameMainTransportOptions;
    IFrameInternal: IFrameTransportInternalOptions;
    BrowserExtensions: BrowserExtensionsGenericTransportOptions;
    BrowserExtensionsMain: BrowserExtensionsMainTransportOptions;
    BrowserExtensionsClient: BrowserExtensionsClientTransportOptions;
    ElectronMain: ElectronMainTransportOptions;
    ElectronRenderer: ElectronRendererTransportOptions;
    ServiceWorkerClient: ServiceWorkerClientTransportOptions;
    ServiceWorkerService: ServiceWorkerServiceTransportOptions;
    WorkerMain: WorkerMainTransportOptions;
    WorkerInternal: WorkerInternalTransportOptions;
    WebRTC: WebRTCTransportOptions;
    Broadcast: BroadcastTransportOptions;
    SharedWorkerClient: SharedWorkerClientTransportOptions;
    SharedWorkerInternal: SharedWorkerInternalTransportOptions;
    Base: TransportOptions;
    MessageTransport: MessageTransportOptions;
    MainProcess: MainProcessTransportOptions;
    ChildProcess: ChildProcessTransportOptions;
}
interface Transports {
    Base: Transport;
    MessageTransport: MessageTransport;
    IFrameMain: IFrameMainTransport;
    IFrameInternal: IFrameInternalTransport;
    SharedWorkerClient: SharedWorkerClientTransport;
    SharedWorkerInternal: SharedWorkerInternalTransport;
    ServiceWorkerClient: ServiceWorkerClientTransport;
    ServiceWorkerService: ServiceWorkerServiceTransport;
    WorkerMain: WorkerMainTransport;
    WorkerInternal: WorkerInternalTransport;
    BrowserExtensions: BrowserExtensionsGenericTransport;
    BrowserExtensionsMain: BrowserExtensionsMainTransport;
    BrowserExtensionsClient: BrowserExtensionsClientTransport;
    ElectronMain: ElectronMainTransport;
    ElectronRenderer: ElectronRendererTransport;
    WebRTC: WebRTCTransport;
    Broadcast: BroadcastTransport;
    MainProcess: MainProcessTransport;
    ChildProcess: ChildProcessTransport;
}
/**
 * Create a transport instance.
 *
 * @param name transport type name
 * @param options transport options
 *
 * @returns Return a transport instance.
 */
export declare const createTransport: <T extends "Base" | "MessageTransport" | "IFrameMain" | "IFrameInternal" | "BrowserExtensions" | "BrowserExtensionsMain" | "BrowserExtensionsClient" | "ElectronMain" | "ElectronRenderer" | "ServiceWorkerClient" | "ServiceWorkerService" | "WorkerMain" | "WorkerInternal" | "WebRTC" | "Broadcast" | "SharedWorkerClient" | "SharedWorkerInternal" | "MainProcess" | "ChildProcess">(name: T, options: TransportOptionsMap[T]) => Transports[T];
export {};
//# sourceMappingURL=createTransport.d.ts.map