'use strict';

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, basedir, module) {
	return module = {
		path: basedir,
		exports: {},
		require: function (path, base) {
			return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
		}
	}, fn(module, module.exports), module.exports;
}

function getAugmentedNamespace(n) {
	if (n.__esModule) return n;
	var a = Object.defineProperty({}, '__esModule', {value: true});
	Object.keys(n).forEach(function (k) {
		var d = Object.getOwnPropertyDescriptor(n, k);
		Object.defineProperty(a, k, d.get ? d : {
			enumerable: true,
			get: function () {
				return n[k];
			}
		});
	});
	return a;
}

function commonjsRequire () {
	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
}

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.push(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.push(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
}
function __runInitializers(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
}
function __propKey(x) {
    return typeof x === "symbol" ? x : "".concat(x);
}
function __setFunctionName(f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
}
function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var __createBinding = Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
});

function __exportStar(m, o) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p)) __createBinding(o, m, p);
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

/** @deprecated */
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

/** @deprecated */
function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

function __await(v) {
    return this instanceof __await ? (this.v = v, this) : new __await(v);
}

function __asyncGenerator(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
}

function __asyncDelegator(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
}

function __asyncValues(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}
var __setModuleDefault = Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
};

function __importStar(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
}

function __importDefault(mod) {
    return (mod && mod.__esModule) ? mod : { default: mod };
}

function __classPrivateFieldGet(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
}

function __classPrivateFieldSet(receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
}

function __classPrivateFieldIn(state, receiver) {
    if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
    return typeof state === "function" ? receiver === state : state.has(receiver);
}

var tslib_es6 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	__extends: __extends,
	get __assign () { return __assign; },
	__rest: __rest,
	__decorate: __decorate,
	__param: __param,
	__esDecorate: __esDecorate,
	__runInitializers: __runInitializers,
	__propKey: __propKey,
	__setFunctionName: __setFunctionName,
	__metadata: __metadata,
	__awaiter: __awaiter,
	__generator: __generator,
	__createBinding: __createBinding,
	__exportStar: __exportStar,
	__values: __values,
	__read: __read,
	__spread: __spread,
	__spreadArrays: __spreadArrays,
	__spreadArray: __spreadArray,
	__await: __await,
	__asyncGenerator: __asyncGenerator,
	__asyncDelegator: __asyncDelegator,
	__asyncValues: __asyncValues,
	__makeTemplateObject: __makeTemplateObject,
	__importStar: __importStar,
	__importDefault: __importDefault,
	__classPrivateFieldGet: __classPrivateFieldGet,
	__classPrivateFieldSet: __classPrivateFieldSet,
	__classPrivateFieldIn: __classPrivateFieldIn
});

var constant = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.transportType = exports.transportKey = exports.beforeEmitResolveKey = exports.beforeEmitKey = exports.produceKey = exports.prefixKey = exports.timeoutKey = exports.callbackKey = exports.originalListensMapKey = exports.verboseKey = exports.logKey = exports.serializerKey = exports.listensMapKey = exports.requestsMapKey = exports.senderKey = exports.listenKey = exports.listenerKey = void 0;
exports.listenerKey = Symbol('listener');
exports.listenKey = Symbol('listen');
exports.senderKey = Symbol('sender');
exports.requestsMapKey = Symbol('requestsMap');
exports.listensMapKey = Symbol('listensMap');
exports.serializerKey = Symbol('serializer');
exports.logKey = Symbol('log');
exports.verboseKey = Symbol('verbose');
exports.originalListensMapKey = Symbol('originalListensMap');
exports.callbackKey = Symbol('callback');
exports.timeoutKey = Symbol('timeout');
exports.prefixKey = Symbol('prefix');
exports.produceKey = Symbol('produce');
exports.beforeEmitKey = Symbol('beforeEmit');
exports.beforeEmitResolveKey = Symbol('beforeEmitResolve');
exports.transportKey = '__DATA_TRANSPORT_UUID__';
exports.transportType = {
    request: 'request',
    response: 'response',
};

});

var tslib_1 = /*@__PURE__*/getAugmentedNamespace(tslib_es6);

var listen_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.listen = void 0;


var listen = function (target, key, descriptor) {
    var _a;
    var fn = descriptor.value;
    {
        if (typeof fn !== 'function') {
            console.warn("The decorator '@listen' can only decorate methods, '".concat(key, "' is NOT a methods."));
            return descriptor;
        }
    }
    target[constant.originalListensMapKey] = (_a = target[constant.originalListensMapKey]) !== null && _a !== void 0 ? _a : new Map();
    target[constant.originalListensMapKey].set(key, fn);
    return tslib_1.__assign(tslib_1.__assign({}, descriptor), { value: function () {
            {
                throw new Error("The method '".concat(key, "' is a listen function that can NOT be actively called."));
            }
        } });
};
exports.listen = listen;

});

var decorators = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });

tslib_1.__exportStar(listen_1, exports);

});

// Unique ID creation requires a high quality random # generator. In the browser we therefore
// require the crypto API and do not support built-in fallback to lower quality random number
// generators (like Math.random()).
let getRandomValues;
const rnds8 = new Uint8Array(16);
function rng() {
  // lazy load so that environments that need to polyfill have a chance to do so
  if (!getRandomValues) {
    // getRandomValues needs to be invoked in a context where "this" is a Crypto implementation.
    getRandomValues = typeof crypto !== 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto);

    if (!getRandomValues) {
      throw new Error('crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported');
    }
  }

  return getRandomValues(rnds8);
}

var REGEX = /^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;

function validate(uuid) {
  return typeof uuid === 'string' && REGEX.test(uuid);
}

/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */

const byteToHex = [];

for (let i = 0; i < 256; ++i) {
  byteToHex.push((i + 0x100).toString(16).slice(1));
}

function unsafeStringify(arr, offset = 0) {
  // Note: Be careful editing this code!  It's been tuned for performance
  // and works in ways you may not expect. See https://github.com/uuidjs/uuid/pull/434
  return (byteToHex[arr[offset + 0]] + byteToHex[arr[offset + 1]] + byteToHex[arr[offset + 2]] + byteToHex[arr[offset + 3]] + '-' + byteToHex[arr[offset + 4]] + byteToHex[arr[offset + 5]] + '-' + byteToHex[arr[offset + 6]] + byteToHex[arr[offset + 7]] + '-' + byteToHex[arr[offset + 8]] + byteToHex[arr[offset + 9]] + '-' + byteToHex[arr[offset + 10]] + byteToHex[arr[offset + 11]] + byteToHex[arr[offset + 12]] + byteToHex[arr[offset + 13]] + byteToHex[arr[offset + 14]] + byteToHex[arr[offset + 15]]).toLowerCase();
}

function stringify(arr, offset = 0) {
  const uuid = unsafeStringify(arr, offset); // Consistency check for valid UUID.  If this throws, it's likely due to one
  // of the following:
  // - One or more input array values don't map to a hex octet (leading to
  // "undefined" in the uuid)
  // - Invalid input values for the RFC `version` or `variant` fields

  if (!validate(uuid)) {
    throw TypeError('Stringified UUID is invalid');
  }

  return uuid;
}

//
// Inspired by https://github.com/LiosK/UUID.js
// and http://docs.python.org/library/uuid.html

let _nodeId;

let _clockseq; // Previous uuid creation time


let _lastMSecs = 0;
let _lastNSecs = 0; // See https://github.com/uuidjs/uuid for API details

function v1(options, buf, offset) {
  let i = buf && offset || 0;
  const b = buf || new Array(16);
  options = options || {};
  let node = options.node || _nodeId;
  let clockseq = options.clockseq !== undefined ? options.clockseq : _clockseq; // node and clockseq need to be initialized to random values if they're not
  // specified.  We do this lazily to minimize issues related to insufficient
  // system entropy.  See #189

  if (node == null || clockseq == null) {
    const seedBytes = options.random || (options.rng || rng)();

    if (node == null) {
      // Per 4.5, create and 48-bit node id, (47 random bits + multicast bit = 1)
      node = _nodeId = [seedBytes[0] | 0x01, seedBytes[1], seedBytes[2], seedBytes[3], seedBytes[4], seedBytes[5]];
    }

    if (clockseq == null) {
      // Per 4.2.2, randomize (14 bit) clockseq
      clockseq = _clockseq = (seedBytes[6] << 8 | seedBytes[7]) & 0x3fff;
    }
  } // UUID timestamps are 100 nano-second units since the Gregorian epoch,
  // (1582-10-15 00:00).  JSNumbers aren't precise enough for this, so
  // time is handled internally as 'msecs' (integer milliseconds) and 'nsecs'
  // (100-nanoseconds offset from msecs) since unix epoch, 1970-01-01 00:00.


  let msecs = options.msecs !== undefined ? options.msecs : Date.now(); // Per 4.2.1.2, use count of uuid's generated during the current clock
  // cycle to simulate higher resolution clock

  let nsecs = options.nsecs !== undefined ? options.nsecs : _lastNSecs + 1; // Time since last uuid creation (in msecs)

  const dt = msecs - _lastMSecs + (nsecs - _lastNSecs) / 10000; // Per 4.2.1.2, Bump clockseq on clock regression

  if (dt < 0 && options.clockseq === undefined) {
    clockseq = clockseq + 1 & 0x3fff;
  } // Reset nsecs if clock regresses (new clockseq) or we've moved onto a new
  // time interval


  if ((dt < 0 || msecs > _lastMSecs) && options.nsecs === undefined) {
    nsecs = 0;
  } // Per 4.2.1.2 Throw error if too many uuids are requested


  if (nsecs >= 10000) {
    throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");
  }

  _lastMSecs = msecs;
  _lastNSecs = nsecs;
  _clockseq = clockseq; // Per 4.1.4 - Convert from unix epoch to Gregorian epoch

  msecs += 12219292800000; // `time_low`

  const tl = ((msecs & 0xfffffff) * 10000 + nsecs) % 0x100000000;
  b[i++] = tl >>> 24 & 0xff;
  b[i++] = tl >>> 16 & 0xff;
  b[i++] = tl >>> 8 & 0xff;
  b[i++] = tl & 0xff; // `time_mid`

  const tmh = msecs / 0x100000000 * 10000 & 0xfffffff;
  b[i++] = tmh >>> 8 & 0xff;
  b[i++] = tmh & 0xff; // `time_high_and_version`

  b[i++] = tmh >>> 24 & 0xf | 0x10; // include version

  b[i++] = tmh >>> 16 & 0xff; // `clock_seq_hi_and_reserved` (Per 4.2.2 - include variant)

  b[i++] = clockseq >>> 8 | 0x80; // `clock_seq_low`

  b[i++] = clockseq & 0xff; // `node`

  for (let n = 0; n < 6; ++n) {
    b[i + n] = node[n];
  }

  return buf || unsafeStringify(b);
}

function parse(uuid) {
  if (!validate(uuid)) {
    throw TypeError('Invalid UUID');
  }

  let v;
  const arr = new Uint8Array(16); // Parse ########-....-....-....-............

  arr[0] = (v = parseInt(uuid.slice(0, 8), 16)) >>> 24;
  arr[1] = v >>> 16 & 0xff;
  arr[2] = v >>> 8 & 0xff;
  arr[3] = v & 0xff; // Parse ........-####-....-....-............

  arr[4] = (v = parseInt(uuid.slice(9, 13), 16)) >>> 8;
  arr[5] = v & 0xff; // Parse ........-....-####-....-............

  arr[6] = (v = parseInt(uuid.slice(14, 18), 16)) >>> 8;
  arr[7] = v & 0xff; // Parse ........-....-....-####-............

  arr[8] = (v = parseInt(uuid.slice(19, 23), 16)) >>> 8;
  arr[9] = v & 0xff; // Parse ........-....-....-....-############
  // (Use "/" to avoid 32-bit truncation when bit-shifting high-order bytes)

  arr[10] = (v = parseInt(uuid.slice(24, 36), 16)) / 0x10000000000 & 0xff;
  arr[11] = v / 0x100000000 & 0xff;
  arr[12] = v >>> 24 & 0xff;
  arr[13] = v >>> 16 & 0xff;
  arr[14] = v >>> 8 & 0xff;
  arr[15] = v & 0xff;
  return arr;
}

function stringToBytes(str) {
  str = unescape(encodeURIComponent(str)); // UTF8 escape

  const bytes = [];

  for (let i = 0; i < str.length; ++i) {
    bytes.push(str.charCodeAt(i));
  }

  return bytes;
}

const DNS = '6ba7b810-9dad-11d1-80b4-00c04fd430c8';
const URL = '6ba7b811-9dad-11d1-80b4-00c04fd430c8';
function v35(name, version, hashfunc) {
  function generateUUID(value, namespace, buf, offset) {
    var _namespace;

    if (typeof value === 'string') {
      value = stringToBytes(value);
    }

    if (typeof namespace === 'string') {
      namespace = parse(namespace);
    }

    if (((_namespace = namespace) === null || _namespace === void 0 ? void 0 : _namespace.length) !== 16) {
      throw TypeError('Namespace must be array-like (16 iterable integer values, 0-255)');
    } // Compute hash of namespace and value, Per 4.3
    // Future: Use spread syntax when supported on all platforms, e.g. `bytes =
    // hashfunc([...namespace, ... value])`


    let bytes = new Uint8Array(16 + value.length);
    bytes.set(namespace);
    bytes.set(value, namespace.length);
    bytes = hashfunc(bytes);
    bytes[6] = bytes[6] & 0x0f | version;
    bytes[8] = bytes[8] & 0x3f | 0x80;

    if (buf) {
      offset = offset || 0;

      for (let i = 0; i < 16; ++i) {
        buf[offset + i] = bytes[i];
      }

      return buf;
    }

    return unsafeStringify(bytes);
  } // Function#name is not settable on some platforms (#270)


  try {
    generateUUID.name = name; // eslint-disable-next-line no-empty
  } catch (err) {} // For CommonJS default export support


  generateUUID.DNS = DNS;
  generateUUID.URL = URL;
  return generateUUID;
}

/*
 * Browser-compatible JavaScript MD5
 *
 * Modification of JavaScript MD5
 * https://github.com/blueimp/JavaScript-MD5
 *
 * Copyright 2011, Sebastian Tschan
 * https://blueimp.net
 *
 * Licensed under the MIT license:
 * https://opensource.org/licenses/MIT
 *
 * Based on
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */
function md5(bytes) {
  if (typeof bytes === 'string') {
    const msg = unescape(encodeURIComponent(bytes)); // UTF8 escape

    bytes = new Uint8Array(msg.length);

    for (let i = 0; i < msg.length; ++i) {
      bytes[i] = msg.charCodeAt(i);
    }
  }

  return md5ToHexEncodedArray(wordsToMd5(bytesToWords(bytes), bytes.length * 8));
}
/*
 * Convert an array of little-endian words to an array of bytes
 */


function md5ToHexEncodedArray(input) {
  const output = [];
  const length32 = input.length * 32;
  const hexTab = '0123456789abcdef';

  for (let i = 0; i < length32; i += 8) {
    const x = input[i >> 5] >>> i % 32 & 0xff;
    const hex = parseInt(hexTab.charAt(x >>> 4 & 0x0f) + hexTab.charAt(x & 0x0f), 16);
    output.push(hex);
  }

  return output;
}
/**
 * Calculate output length with padding and bit length
 */


function getOutputLength(inputLength8) {
  return (inputLength8 + 64 >>> 9 << 4) + 14 + 1;
}
/*
 * Calculate the MD5 of an array of little-endian words, and a bit length.
 */


function wordsToMd5(x, len) {
  /* append padding */
  x[len >> 5] |= 0x80 << len % 32;
  x[getOutputLength(len) - 1] = len;
  let a = 1732584193;
  let b = -271733879;
  let c = -1732584194;
  let d = 271733878;

  for (let i = 0; i < x.length; i += 16) {
    const olda = a;
    const oldb = b;
    const oldc = c;
    const oldd = d;
    a = md5ff(a, b, c, d, x[i], 7, -680876936);
    d = md5ff(d, a, b, c, x[i + 1], 12, -389564586);
    c = md5ff(c, d, a, b, x[i + 2], 17, 606105819);
    b = md5ff(b, c, d, a, x[i + 3], 22, -1044525330);
    a = md5ff(a, b, c, d, x[i + 4], 7, -176418897);
    d = md5ff(d, a, b, c, x[i + 5], 12, 1200080426);
    c = md5ff(c, d, a, b, x[i + 6], 17, -1473231341);
    b = md5ff(b, c, d, a, x[i + 7], 22, -45705983);
    a = md5ff(a, b, c, d, x[i + 8], 7, 1770035416);
    d = md5ff(d, a, b, c, x[i + 9], 12, -1958414417);
    c = md5ff(c, d, a, b, x[i + 10], 17, -42063);
    b = md5ff(b, c, d, a, x[i + 11], 22, -1990404162);
    a = md5ff(a, b, c, d, x[i + 12], 7, 1804603682);
    d = md5ff(d, a, b, c, x[i + 13], 12, -40341101);
    c = md5ff(c, d, a, b, x[i + 14], 17, -1502002290);
    b = md5ff(b, c, d, a, x[i + 15], 22, 1236535329);
    a = md5gg(a, b, c, d, x[i + 1], 5, -165796510);
    d = md5gg(d, a, b, c, x[i + 6], 9, -1069501632);
    c = md5gg(c, d, a, b, x[i + 11], 14, 643717713);
    b = md5gg(b, c, d, a, x[i], 20, -373897302);
    a = md5gg(a, b, c, d, x[i + 5], 5, -701558691);
    d = md5gg(d, a, b, c, x[i + 10], 9, 38016083);
    c = md5gg(c, d, a, b, x[i + 15], 14, -660478335);
    b = md5gg(b, c, d, a, x[i + 4], 20, -405537848);
    a = md5gg(a, b, c, d, x[i + 9], 5, 568446438);
    d = md5gg(d, a, b, c, x[i + 14], 9, -1019803690);
    c = md5gg(c, d, a, b, x[i + 3], 14, -187363961);
    b = md5gg(b, c, d, a, x[i + 8], 20, 1163531501);
    a = md5gg(a, b, c, d, x[i + 13], 5, -1444681467);
    d = md5gg(d, a, b, c, x[i + 2], 9, -51403784);
    c = md5gg(c, d, a, b, x[i + 7], 14, 1735328473);
    b = md5gg(b, c, d, a, x[i + 12], 20, -1926607734);
    a = md5hh(a, b, c, d, x[i + 5], 4, -378558);
    d = md5hh(d, a, b, c, x[i + 8], 11, -2022574463);
    c = md5hh(c, d, a, b, x[i + 11], 16, 1839030562);
    b = md5hh(b, c, d, a, x[i + 14], 23, -35309556);
    a = md5hh(a, b, c, d, x[i + 1], 4, -1530992060);
    d = md5hh(d, a, b, c, x[i + 4], 11, 1272893353);
    c = md5hh(c, d, a, b, x[i + 7], 16, -155497632);
    b = md5hh(b, c, d, a, x[i + 10], 23, -1094730640);
    a = md5hh(a, b, c, d, x[i + 13], 4, 681279174);
    d = md5hh(d, a, b, c, x[i], 11, -358537222);
    c = md5hh(c, d, a, b, x[i + 3], 16, -722521979);
    b = md5hh(b, c, d, a, x[i + 6], 23, 76029189);
    a = md5hh(a, b, c, d, x[i + 9], 4, -640364487);
    d = md5hh(d, a, b, c, x[i + 12], 11, -421815835);
    c = md5hh(c, d, a, b, x[i + 15], 16, 530742520);
    b = md5hh(b, c, d, a, x[i + 2], 23, -995338651);
    a = md5ii(a, b, c, d, x[i], 6, -198630844);
    d = md5ii(d, a, b, c, x[i + 7], 10, 1126891415);
    c = md5ii(c, d, a, b, x[i + 14], 15, -1416354905);
    b = md5ii(b, c, d, a, x[i + 5], 21, -57434055);
    a = md5ii(a, b, c, d, x[i + 12], 6, 1700485571);
    d = md5ii(d, a, b, c, x[i + 3], 10, -1894986606);
    c = md5ii(c, d, a, b, x[i + 10], 15, -1051523);
    b = md5ii(b, c, d, a, x[i + 1], 21, -2054922799);
    a = md5ii(a, b, c, d, x[i + 8], 6, 1873313359);
    d = md5ii(d, a, b, c, x[i + 15], 10, -30611744);
    c = md5ii(c, d, a, b, x[i + 6], 15, -1560198380);
    b = md5ii(b, c, d, a, x[i + 13], 21, 1309151649);
    a = md5ii(a, b, c, d, x[i + 4], 6, -145523070);
    d = md5ii(d, a, b, c, x[i + 11], 10, -1120210379);
    c = md5ii(c, d, a, b, x[i + 2], 15, 718787259);
    b = md5ii(b, c, d, a, x[i + 9], 21, -343485551);
    a = safeAdd(a, olda);
    b = safeAdd(b, oldb);
    c = safeAdd(c, oldc);
    d = safeAdd(d, oldd);
  }

  return [a, b, c, d];
}
/*
 * Convert an array bytes to an array of little-endian words
 * Characters >255 have their high-byte silently ignored.
 */


function bytesToWords(input) {
  if (input.length === 0) {
    return [];
  }

  const length8 = input.length * 8;
  const output = new Uint32Array(getOutputLength(length8));

  for (let i = 0; i < length8; i += 8) {
    output[i >> 5] |= (input[i / 8] & 0xff) << i % 32;
  }

  return output;
}
/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */


function safeAdd(x, y) {
  const lsw = (x & 0xffff) + (y & 0xffff);
  const msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return msw << 16 | lsw & 0xffff;
}
/*
 * Bitwise rotate a 32-bit number to the left.
 */


function bitRotateLeft(num, cnt) {
  return num << cnt | num >>> 32 - cnt;
}
/*
 * These functions implement the four basic operations the algorithm uses.
 */


function md5cmn(q, a, b, x, s, t) {
  return safeAdd(bitRotateLeft(safeAdd(safeAdd(a, q), safeAdd(x, t)), s), b);
}

function md5ff(a, b, c, d, x, s, t) {
  return md5cmn(b & c | ~b & d, a, b, x, s, t);
}

function md5gg(a, b, c, d, x, s, t) {
  return md5cmn(b & d | c & ~d, a, b, x, s, t);
}

function md5hh(a, b, c, d, x, s, t) {
  return md5cmn(b ^ c ^ d, a, b, x, s, t);
}

function md5ii(a, b, c, d, x, s, t) {
  return md5cmn(c ^ (b | ~d), a, b, x, s, t);
}

const v3 = v35('v3', 0x30, md5);

const randomUUID = typeof crypto !== 'undefined' && crypto.randomUUID && crypto.randomUUID.bind(crypto);
var native = {
  randomUUID
};

function v4(options, buf, offset) {
  if (native.randomUUID && !buf && !options) {
    return native.randomUUID();
  }

  options = options || {};
  const rnds = options.random || (options.rng || rng)(); // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`

  rnds[6] = rnds[6] & 0x0f | 0x40;
  rnds[8] = rnds[8] & 0x3f | 0x80; // Copy bytes to buffer, if provided

  if (buf) {
    offset = offset || 0;

    for (let i = 0; i < 16; ++i) {
      buf[offset + i] = rnds[i];
    }

    return buf;
  }

  return unsafeStringify(rnds);
}

// Adapted from Chris Veness' SHA1 code at
// http://www.movable-type.co.uk/scripts/sha1.html
function f(s, x, y, z) {
  switch (s) {
    case 0:
      return x & y ^ ~x & z;

    case 1:
      return x ^ y ^ z;

    case 2:
      return x & y ^ x & z ^ y & z;

    case 3:
      return x ^ y ^ z;
  }
}

function ROTL(x, n) {
  return x << n | x >>> 32 - n;
}

function sha1(bytes) {
  const K = [0x5a827999, 0x6ed9eba1, 0x8f1bbcdc, 0xca62c1d6];
  const H = [0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0];

  if (typeof bytes === 'string') {
    const msg = unescape(encodeURIComponent(bytes)); // UTF8 escape

    bytes = [];

    for (let i = 0; i < msg.length; ++i) {
      bytes.push(msg.charCodeAt(i));
    }
  } else if (!Array.isArray(bytes)) {
    // Convert Array-like to Array
    bytes = Array.prototype.slice.call(bytes);
  }

  bytes.push(0x80);
  const l = bytes.length / 4 + 2;
  const N = Math.ceil(l / 16);
  const M = new Array(N);

  for (let i = 0; i < N; ++i) {
    const arr = new Uint32Array(16);

    for (let j = 0; j < 16; ++j) {
      arr[j] = bytes[i * 64 + j * 4] << 24 | bytes[i * 64 + j * 4 + 1] << 16 | bytes[i * 64 + j * 4 + 2] << 8 | bytes[i * 64 + j * 4 + 3];
    }

    M[i] = arr;
  }

  M[N - 1][14] = (bytes.length - 1) * 8 / Math.pow(2, 32);
  M[N - 1][14] = Math.floor(M[N - 1][14]);
  M[N - 1][15] = (bytes.length - 1) * 8 & 0xffffffff;

  for (let i = 0; i < N; ++i) {
    const W = new Uint32Array(80);

    for (let t = 0; t < 16; ++t) {
      W[t] = M[i][t];
    }

    for (let t = 16; t < 80; ++t) {
      W[t] = ROTL(W[t - 3] ^ W[t - 8] ^ W[t - 14] ^ W[t - 16], 1);
    }

    let a = H[0];
    let b = H[1];
    let c = H[2];
    let d = H[3];
    let e = H[4];

    for (let t = 0; t < 80; ++t) {
      const s = Math.floor(t / 20);
      const T = ROTL(a, 5) + f(s, b, c, d) + e + K[s] + W[t] >>> 0;
      e = d;
      d = c;
      c = ROTL(b, 30) >>> 0;
      b = a;
      a = T;
    }

    H[0] = H[0] + a >>> 0;
    H[1] = H[1] + b >>> 0;
    H[2] = H[2] + c >>> 0;
    H[3] = H[3] + d >>> 0;
    H[4] = H[4] + e >>> 0;
  }

  return [H[0] >> 24 & 0xff, H[0] >> 16 & 0xff, H[0] >> 8 & 0xff, H[0] & 0xff, H[1] >> 24 & 0xff, H[1] >> 16 & 0xff, H[1] >> 8 & 0xff, H[1] & 0xff, H[2] >> 24 & 0xff, H[2] >> 16 & 0xff, H[2] >> 8 & 0xff, H[2] & 0xff, H[3] >> 24 & 0xff, H[3] >> 16 & 0xff, H[3] >> 8 & 0xff, H[3] & 0xff, H[4] >> 24 & 0xff, H[4] >> 16 & 0xff, H[4] >> 8 & 0xff, H[4] & 0xff];
}

const v5 = v35('v5', 0x50, sha1);

var nil = '00000000-0000-0000-0000-000000000000';

function version(uuid) {
  if (!validate(uuid)) {
    throw TypeError('Invalid UUID');
  }

  return parseInt(uuid.slice(14, 15), 16);
}

var esmBrowser = /*#__PURE__*/Object.freeze({
	__proto__: null,
	v1: v1,
	v3: v3,
	v4: v4,
	v5: v5,
	NIL: nil,
	version: version,
	validate: validate,
	stringify: stringify,
	parse: parse
});

var uuid_1 = /*@__PURE__*/getAugmentedNamespace(esmBrowser);

var utils = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateId = exports.detectSafari = void 0;

var detectSafari = function () {
    return /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
};
exports.detectSafari = detectSafari;
var generateId = function () {
    return (0, uuid_1.v4)({
        // In nodejs, crypto.getRandomValues() not supported.
        // workaround: https://github.com/uuidjs/uuid/issues/375
        rng: function () {
            var randomNumbers = new Array(16);
            var r;
            for (var i = 0; i < 16; i++) {
                if ((i & 0x03) === 0)
                    r = Math.random() * 0x100000000;
                randomNumbers[i] = (r >>> ((i & 0x03) << 3)) & 0xff;
            }
            return randomNumbers;
        },
    });
};
exports.generateId = generateId;

});

var transport = createCommonjsModule(function (module, exports) {
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transport = exports.getAction = void 0;



var DEFAULT_TIMEOUT = 60 * 1000;
var DEFAULT_RESPOND = true;
var DEFAULT_SILENT = false;
var DEFAULT_PREFIX = 'DataTransport';
var getAction = function (prefix, name) {
    return "".concat(prefix, "-").concat(name.toString());
};
exports.getAction = getAction;
var getListenName = function (prefix, action) {
    return action.replace(new RegExp("^".concat(prefix, "-")), '');
};
/**
 * Create a base transport
 */
var Transport = /** @class */ (function () {
    function Transport(_b) {
        var listener = _b.listener, sender = _b.sender, _c = _b.timeout, timeout = _c === void 0 ? DEFAULT_TIMEOUT : _c, _d = _b.verbose, verbose = _d === void 0 ? false : _d, _e = _b.prefix, prefix = _e === void 0 ? DEFAULT_PREFIX : _e, _f = _b.listenKeys, listenKeys = _f === void 0 ? [] : _f, _g = _b.checkListen, checkListen = _g === void 0 ? true : _g, serializer = _b.serializer, logger = _b.logger;
        var _this = this;
        var _h, _j;
        this[_a] = new Map();
        this.id = (0, utils.generateId)();
        this[constant.listensMapKey] = (_h = this[constant.listensMapKey]) !== null && _h !== void 0 ? _h : new Map();
        this[constant.originalListensMapKey] = (_j = this[constant.originalListensMapKey]) !== null && _j !== void 0 ? _j : new Map();
        this[constant.listenerKey] = listener.bind(this);
        this[constant.senderKey] = sender.bind(this);
        this[constant.timeoutKey] = timeout;
        this[constant.prefixKey] = prefix;
        this[constant.serializerKey] = serializer;
        this[constant.verboseKey] = verbose;
        this[constant.logKey] = logger;
        new Set(listenKeys).forEach(function (key) {
            var _b;
            var fn = _this[key];
            {
                if (typeof fn !== 'function') {
                    console.warn("'".concat(key, "' is NOT a methods or function."));
                }
            }
            _this[constant.originalListensMapKey].set(key, fn);
            Object.assign(_this, (_b = {},
                _b[key] = function () {
                    {
                        throw new Error("The method '".concat(key, "' is a listen function that can NOT be actively called."));
                    }
                },
                _b));
        });
        this[constant.originalListensMapKey].forEach(function (value, name) {
            _this[constant.produceKey](name, value);
        });
        this[constant.listenKey] = function (options) {
            var _b, _c;
            if (_this[constant.verboseKey]) {
                if (typeof _this[constant.logKey] === 'function' && options) {
                    _this[constant.logKey](options);
                }
                else {
                    console.info('DataTransport Receive: ', options);
                }
            }
            if (options === null || options === void 0 ? void 0 : options[constant.transportKey]) {
                var listenName = getListenName(_this[constant.prefixKey], options.action);
                var hasListen = typeof _this[listenName] === 'function';
                if (options.type === constant.transportType.response) {
                    var resolve = _this[constant.requestsMapKey].get(options[constant.transportKey]);
                    if (resolve) {
                        var response = options.response;
                        resolve(typeof response === 'string' && ((_b = _this[constant.serializerKey]) === null || _b === void 0 ? void 0 : _b.parse)
                            ? _this[constant.serializerKey].parse(response)
                            : response);
                    }
                    else if (hasListen) {
                        if ( checkListen) {
                            console.warn("The type '".concat(options.action, "' event '").concat(options[constant.transportKey], "' has been resolved. Please check for a duplicate response."));
                        }
                    }
                }
                else if (options.type === constant.transportType.request) {
                    var respond = _this[constant.listensMapKey].get(options.action);
                    if (typeof respond === 'function') {
                        var request = options.request;
                        respond(typeof request === 'string' && ((_c = _this[constant.serializerKey]) === null || _c === void 0 ? void 0 : _c.parse)
                            ? _this[constant.serializerKey].parse(request)
                            : request, tslib_1.__assign(tslib_1.__assign({}, options), { transportId: options[constant.transportKey], hasRespond: options.hasRespond }));
                    }
                    else if (hasListen) {
                        if ( checkListen) {
                            console.error("The listen method or function '".concat(listenName, "' is NOT decorated by decorator '@listen' or be added 'listenKeys' list."));
                        }
                    }
                }
            }
        };
        var dispose = this[constant.listenerKey](this[constant.listenKey]);
        this.dispose = function () {
            if (typeof dispose === 'function') {
                _this[constant.requestsMapKey].clear();
                _this[constant.listensMapKey].clear();
                _this[constant.originalListensMapKey].clear();
                return dispose();
            }
            else {
                console.warn("The return value of the the '".concat(_this.constructor.name, "' transport's listener should be a 'dispose' function for removing the listener"));
            }
        };
    }
    Transport.prototype[(_a = constant.requestsMapKey, constant.produceKey)] = function (name, fn) {
        var _this = this;
        // https://github.com/microsoft/TypeScript/issues/40465
        var action = (0, exports.getAction)(this[constant.prefixKey], name);
        this[constant.listensMapKey].set(action, function (request, _b) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var response, data;
            var _c;
            var _d;
            var hasRespond = _b.hasRespond, transportId = _b.transportId; _b.request; var args = tslib_1.__rest(_b, ["hasRespond", "transportId", "request"]);
            return tslib_1.__generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        if (!(typeof fn === 'function')) return [3 /*break*/, 2];
                        return [4 /*yield*/, fn.apply(this, request)];
                    case 1:
                        response = _e.sent();
                        if (!hasRespond)
                            return [2 /*return*/];
                        data = tslib_1.__assign(tslib_1.__assign({}, args), (_c = { action: action, response: (typeof response !== 'undefined' &&
                                    ((_d = this[constant.serializerKey]) === null || _d === void 0 ? void 0 : _d.stringify)
                                    ? this[constant.serializerKey].stringify(response)
                                    : response), hasRespond: hasRespond }, _c[constant.transportKey] = transportId, _c.type = constant.transportType.response, _c.responseId = this.id, _c));
                        this[constant.senderKey](data);
                        return [3 /*break*/, 3];
                    case 2: throw new Error("The listener for event ".concat(name, " should be a function."));
                    case 3: return [2 /*return*/];
                }
            });
        }); });
    };
    /**
     * Listen an event that transport data.
     *
     * @param name A transport action as listen message data action type
     * @param fn A transport listener
     */
    Transport.prototype.listen = function (name, fn) {
        var _this = this;
        if (typeof name === 'string') {
            if (this[constant.originalListensMapKey].get(name)) {
                throw new Error("Failed to listen to the event \"".concat(name, "\", the event \"").concat(name, "\" is already listened to."));
            }
            if (typeof fn === 'function') {
                this[constant.originalListensMapKey].set(name, fn);
                this[constant.produceKey](name, fn);
            }
            else {
                throw new Error("The listener for event ".concat(name, " should be a function."));
            }
        }
        else {
            throw new Error("The event name \"".concat(name.toString(), "\" is not a string, it should be a string."));
        }
        return function () {
            _this[constant.originalListensMapKey].delete(name);
            var action = (0, exports.getAction)(_this[constant.prefixKey], name);
            _this[constant.listensMapKey].delete(action);
        };
    };
    /**
     * Emit an event that transport data.
     *
     * @param emitOptions A option for the transport data
     * @param request A request data
     *
     * @returns Return a response for the request.
     */
    Transport.prototype.emit = function (options) {
        var _b, _c, _d, _e, _f;
        var request = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            request[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var params, hasRespond, isSilent, timeout, name, transportId, action, rawRequestData, timeoutId, promise;
            var _g;
            var _this = this;
            return tslib_1.__generator(this, function (_h) {
                switch (_h.label) {
                    case 0:
                        params = typeof options === 'object' ? options : {};
                        hasRespond = (_b = params.respond) !== null && _b !== void 0 ? _b : DEFAULT_RESPOND;
                        isSilent = (_c = params.silent) !== null && _c !== void 0 ? _c : DEFAULT_SILENT;
                        timeout = (_d = params.timeout) !== null && _d !== void 0 ? _d : this[constant.timeoutKey];
                        name = (_e = params.name) !== null && _e !== void 0 ? _e : options;
                        transportId = (0, utils.generateId)();
                        if ( (!name || typeof name !== 'string')) {
                            throw new Error("The event name should be a string, and it's required.");
                        }
                        action = (0, exports.getAction)(this[constant.prefixKey], name);
                        rawRequestData = tslib_1.__assign(tslib_1.__assign({}, (params._extra ? { _extra: params._extra } : {})), (_g = { type: constant.transportType.request, action: action, request: (typeof request !== 'undefined' && ((_f = this[constant.serializerKey]) === null || _f === void 0 ? void 0 : _f.stringify)
                                    ? this[constant.serializerKey].stringify(request)
                                    : request), hasRespond: hasRespond }, _g[constant.transportKey] = transportId, _g.requestId = this.id, _g));
                        if (this[constant.verboseKey]) {
                            if (typeof this[constant.logKey] === 'function') {
                                this[constant.logKey](rawRequestData);
                            }
                            else {
                                console.info('DataTransport Send: ', rawRequestData);
                            }
                        }
                        if (!!hasRespond) return [3 /*break*/, 3];
                        if (!(this[constant.beforeEmitKey] && !params.skipBeforeEmit)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this[constant.beforeEmitKey]];
                    case 1:
                        _h.sent();
                        _h.label = 2;
                    case 2:
                        this[constant.senderKey](rawRequestData);
                        return [2 /*return*/, Promise.resolve(undefined)];
                    case 3:
                        promise = Promise.race([
                            new Promise(function (resolve) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                return tslib_1.__generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!(this[constant.beforeEmitKey] && !params.skipBeforeEmit)) return [3 /*break*/, 2];
                                            return [4 /*yield*/, this[constant.beforeEmitKey]];
                                        case 1:
                                            _b.sent();
                                            _b.label = 2;
                                        case 2:
                                            this[constant.requestsMapKey].set(transportId, resolve);
                                            this[constant.senderKey](rawRequestData);
                                            return [2 /*return*/];
                                    }
                                });
                            }); }),
                            new Promise(function (_, reject) {
                                timeoutId = setTimeout(function () {
                                    reject();
                                }, timeout);
                            }),
                        ]);
                        return [2 /*return*/, promise
                                .then(function (response) {
                                // support Safari 10-11.1
                                clearTimeout(timeoutId);
                                _this[constant.requestsMapKey].delete(transportId);
                                return response;
                            })
                                .catch(function (error) {
                                clearTimeout(timeoutId);
                                _this[constant.requestsMapKey].delete(transportId);
                                if (typeof error === 'undefined') {
                                    if (isSilent)
                                        return;
                                    console.warn("The event '".concat(action, "' timed out for ").concat(timeout, " seconds..."));
                                }
                                else {
                                    {
                                        throw error;
                                    }
                                }
                            })];
                }
            });
        });
    };
    return Transport;
}());
exports.Transport = Transport;

});

var iframeTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.IFrameTransport = exports.IFrameInternalTransport = exports.IFrameMainTransport = void 0;



var connectEventName = 'iframe-connect';
var IFrameMainTransport = /** @class */ (function (_super) {
    tslib_1.__extends(IFrameMainTransport, _super);
    function IFrameMainTransport(_options) {
        var _this = this;
        var _a = _options.iframe, iframe = _a === void 0 ? document.querySelector('iframe') : _a, _b = _options.targetOrigin, targetOrigin = _b === void 0 ? '*' : _b, _c = _options.listener, listener = _c === void 0 ? function (callback) {
            var handler = function (_a) {
                var data = _a.data, source = _a.source;
                var contentWindow = iframe.contentWindow;
                if (contentWindow && contentWindow === source) {
                    return callback(data);
                }
            };
            window.addEventListener('message', handler);
            return function () {
                window.removeEventListener('message', handler);
            };
        } : _c, _d = _options.sender, sender = _d === void 0 ? function (message) {
            if (iframe) {
                iframe.contentWindow.postMessage(message, targetOrigin);
            }
            else if (window.frames[0]) {
                window.frames[0].postMessage(message, targetOrigin);
            }
            else {
                console.error('The current page does not have any iframe elements');
            }
        } : _d, skipConnectionCheck = _options.skipConnectionCheck, options = tslib_1.__rest(_options, ["iframe", "targetOrigin", "listener", "sender", "skipConnectionCheck"]);
        _this = _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
        if (!skipConnectionCheck) {
            var connect_1 = function () {
                _this.emit({
                    // @ts-ignore
                    name: connectEventName,
                    silent: true,
                    skipBeforeEmit: true,
                }).then(function (connected) {
                    if (connected) {
                        _this[constant.beforeEmitResolveKey]();
                    }
                });
            };
            connect_1();
            _this[constant.beforeEmitKey] = new Promise(function (resolve) {
                _this[constant.beforeEmitResolveKey] = resolve;
            });
            // @ts-ignore
            _this.listen(connectEventName, function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    this[constant.beforeEmitResolveKey]();
                    return [2 /*return*/, true];
                });
            }); });
            // for iframe reload
            iframe === null || iframe === void 0 ? void 0 : iframe.addEventListener('load', function () {
                _this[constant.beforeEmitKey] = new Promise(function (resolve) {
                    _this[constant.beforeEmitResolveKey] = resolve;
                });
                connect_1();
            });
        }
        return _this;
    }
    return IFrameMainTransport;
}(transport.Transport));
exports.IFrameMainTransport = IFrameMainTransport;
var IFrameInternalTransport = /** @class */ (function (_super) {
    tslib_1.__extends(IFrameInternalTransport, _super);
    function IFrameInternalTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _this = this;
        var _a = _options.targetOrigin, targetOrigin = _a === void 0 ? '*' : _a, _b = _options.listener, listener = _b === void 0 ? function (callback) {
            var handler = function (_a) {
                var data = _a.data;
                return callback(data);
            };
            window.addEventListener('message', handler);
            return function () {
                window.removeEventListener('message', handler);
            };
        } : _b, _c = _options.sender, sender = _c === void 0 ? function (message) { return window.parent.postMessage(message, targetOrigin); } : _c, skipConnectionCheck = _options.skipConnectionCheck, options = tslib_1.__rest(_options, ["targetOrigin", "listener", "sender", "skipConnectionCheck"]);
        _this = _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
        if (!skipConnectionCheck) {
            _this.emit({
                // @ts-ignore
                name: connectEventName,
                silent: true,
            }).then(function (connected) {
                if (connected) {
                    _this[constant.beforeEmitResolveKey]();
                }
            });
            _this[constant.beforeEmitKey] = new Promise(function (resolve) {
                _this[constant.beforeEmitResolveKey] = resolve;
            });
            // @ts-ignore
            _this.listen(connectEventName, function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    this[constant.beforeEmitResolveKey]();
                    return [2 /*return*/, true];
                });
            }); });
        }
        return _this;
    }
    return IFrameInternalTransport;
}(transport.Transport));
exports.IFrameInternalTransport = IFrameInternalTransport;
exports.IFrameTransport = {
    Main: IFrameMainTransport,
    IFrame: IFrameInternalTransport,
};

});

var workerTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkerTransport = exports.WorkerInternalTransport = exports.WorkerMainTransport = void 0;


var WorkerMainTransport = /** @class */ (function (_super) {
    tslib_1.__extends(WorkerMainTransport, _super);
    function WorkerMainTransport(_options) {
        var worker = _options.worker, _a = _options.listener, listener = _a === void 0 ? function (callback) {
            var handler = function (_a) {
                var data = _a.data;
                callback(data);
            };
            worker.addEventListener('message', handler);
            return function () {
                worker.removeEventListener('message', handler);
            };
        } : _a, _b = _options.sender, sender = _b === void 0 ? function (message) {
            var _a;
            var transfer = (_a = message.transfer) !== null && _a !== void 0 ? _a : [];
            delete message.transfer;
            worker.postMessage(message, transfer);
        } : _b, options = tslib_1.__rest(_options, ["worker", "listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return WorkerMainTransport;
}(transport.Transport));
exports.WorkerMainTransport = WorkerMainTransport;
var WorkerInternalTransport = /** @class */ (function (_super) {
    tslib_1.__extends(WorkerInternalTransport, _super);
    function WorkerInternalTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _a = _options.listener, listener = _a === void 0 ? function (callback) {
            var handler = (function (_a) {
                var data = _a.data;
                callback(data);
            });
            self.addEventListener('message', handler);
            return function () {
                self.removeEventListener('message', handler);
            };
        } : _a, _b = _options.sender, sender = _b === void 0 ? function (message) {
            var _a;
            var transfer = (_a = message.transfer) !== null && _a !== void 0 ? _a : [];
            delete message.transfer;
            postMessage(message, transfer);
        } : _b, options = tslib_1.__rest(_options, ["listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return WorkerInternalTransport;
}(transport.Transport));
exports.WorkerInternalTransport = WorkerInternalTransport;
exports.WorkerTransport = {
    Main: WorkerMainTransport,
    Worker: WorkerInternalTransport,
};

});

var sharedWorkerTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.SharedWorkerTransport = exports.SharedWorkerInternalTransport = exports.SharedWorkerClientTransport = void 0;



var connectEventName = 'sharedworker-connect';
var disconnectEventName = 'sharedworker-disconnect';
var SharedWorkerClientTransport = /** @class */ (function (_super) {
    tslib_1.__extends(SharedWorkerClientTransport, _super);
    function SharedWorkerClientTransport(_options) {
        var _this = this;
        var worker = _options.worker, _a = _options.listener, listener = _a === void 0 ? function (callback) {
            var handler = function (_a) {
                var data = _a.data;
                callback(data);
            };
            worker.port.addEventListener('message', handler);
            worker.port.start();
            return function () {
                worker.port.removeEventListener('message', handler);
            };
        } : _a, _b = _options.sender, sender = _b === void 0 ? function (message) {
            var _a;
            var transfer = (_a = message.transfer) !== null && _a !== void 0 ? _a : [];
            delete message.transfer;
            worker.port.postMessage(message, transfer);
        } : _b, options = tslib_1.__rest(_options, ["worker", "listener", "sender"]);
        _this = _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
        _this._onConnectCallback = new Set();
        // do not use `unload` event
        // https://developer.chrome.com/docs/web-platform/deprecating-unload
        window.addEventListener('pagehide', function () {
            // @ts-ignore
            _this.emit({ name: disconnectEventName, respond: false }, _this.id);
        });
        // @ts-ignore
        _this.listen(connectEventName, function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                Promise.resolve().then(function () {
                    _this._onConnectCallback.forEach(function (callback) {
                        callback();
                    });
                });
                return [2 /*return*/, this.id];
            });
        }); });
        return _this;
    }
    SharedWorkerClientTransport.prototype.onConnect = function (callback) {
        var _this = this;
        this._onConnectCallback.add(callback);
        return function () {
            _this._onConnectCallback.delete(callback);
        };
    };
    return SharedWorkerClientTransport;
}(transport.Transport));
exports.SharedWorkerClientTransport = SharedWorkerClientTransport;
var SharedWorkerInternalTransport = /** @class */ (function (_super) {
    tslib_1.__extends(SharedWorkerInternalTransport, _super);
    function SharedWorkerInternalTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _this = this;
        var _a = _options.listener, listener = _a === void 0 ? function (callback) {
            var _this = this;
            this[constant.callbackKey] = callback;
            return function () {
                _this.ports.forEach(function (port) {
                    port._handler && port.removeEventListener('message', port._handler);
                    delete port._handler;
                });
                self.close();
            };
        } : _a, _b = _options.sender, sender = _b === void 0 ? function (message) {
            var _a, _b;
            var transfer = (_a = message.transfer) !== null && _a !== void 0 ? _a : [];
            delete message.transfer;
            var port = (_b = message._extra) === null || _b === void 0 ? void 0 : _b._port;
            // pick a client port for sender.
            if (port) {
                delete message._extra._port;
                port.postMessage(message, transfer);
            }
            else if (message.type === 'response' &&
                // @ts-ignore
                _this.ports.has(message.requestId)) {
                // @ts-ignore
                var port_1 = _this.ports.get(message.requestId);
                port_1.postMessage(message, transfer);
            }
            else {
                _this.ports.forEach(function (port) {
                    port.postMessage(message, transfer);
                });
                _this.tempPorts.forEach(function (port) {
                    port.postMessage(message, transfer);
                });
            }
        } : _b, options = tslib_1.__rest(_options, ["listener", "sender"]);
        _this = _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
        _this.ports = new Map();
        _this.tempPorts = new Set();
        _this._onConnectCallback = new Set();
        _this._onDisconnectCallback = new Set();
        var disconnectActionName = (0, transport.getAction)(_this[constant.prefixKey], disconnectEventName);
        self.addEventListener('connect', function (e) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var port, id_1, err_1;
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        port = e.ports[0];
                        port._handler = function (_a) {
                            var _b;
                            var data = _a.data;
                            if (data.hasRespond) {
                                data._extra = (_b = data._extra) !== null && _b !== void 0 ? _b : {};
                                data._extra._port = port;
                            }
                            if (data.action === disconnectActionName &&
                                _this.ports.has(data.requestId)) {
                                // clear port and clientId when the port's client is disconnected.
                                _this.ports.delete(data.requestId);
                                _this._onDisconnectCallback.forEach(function (callback) {
                                    callback(data.requestId);
                                });
                            }
                            _this[constant.callbackKey](data);
                        };
                        port.addEventListener('message', port._handler);
                        port.start();
                        this.tempPorts.add(port);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.emit({
                                // @ts-ignore
                                name: connectEventName,
                                _extra: { _port: port },
                            })];
                    case 2:
                        id_1 = _a.sent();
                        this.ports.set(id_1, port);
                        this.tempPorts.delete(port);
                        this._onConnectCallback.forEach(function (callback) {
                            callback(id_1);
                        });
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        this.tempPorts.delete(port);
                        console.error(err_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        return _this;
    }
    SharedWorkerInternalTransport.prototype.onConnect = function (callback) {
        var _this = this;
        this._onConnectCallback.add(callback);
        return function () {
            _this._onConnectCallback.delete(callback);
        };
    };
    SharedWorkerInternalTransport.prototype.onDisconnect = function (callback) {
        var _this = this;
        this._onDisconnectCallback.add(callback);
        return function () {
            _this._onDisconnectCallback.delete(callback);
        };
    };
    return SharedWorkerInternalTransport;
}(transport.Transport));
exports.SharedWorkerInternalTransport = SharedWorkerInternalTransport;
exports.SharedWorkerTransport = {
    Client: SharedWorkerClientTransport,
    Worker: SharedWorkerInternalTransport,
};

});

var serviceWorkerTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceWorkerTransport = exports.ServiceWorkerServiceTransport = exports.ServiceWorkerClientTransport = void 0;



var DEFAULT_USE_ON_SAFARI = true;
var decode = function (data, useOnSafari) {
    try {
        return useOnSafari && (0, utils.detectSafari)() ? JSON.stringify(data) : data;
    }
    catch (e) {
        console.error("Failed to stringify:", data);
        throw e;
    }
};
var encode = function (data, useOnSafari) {
    try {
        return typeof data === 'string' && useOnSafari && (0, utils.detectSafari)()
            ? JSON.parse(data)
            : data;
    }
    catch (e) {
        console.error("Failed to parse:", data);
    }
    return data;
};
var ServiceWorkerClientTransport = /** @class */ (function (_super) {
    tslib_1.__extends(ServiceWorkerClientTransport, _super);
    function ServiceWorkerClientTransport(_options) {
        var worker = _options.worker, _a = _options.useOnSafari, useOnSafari = _a === void 0 ? DEFAULT_USE_ON_SAFARI : _a, _b = _options.listener, listener = _b === void 0 ? function (callback) {
            var handler = function (_a) {
                var data = _a.data;
                callback(encode(data, useOnSafari));
            };
            navigator.serviceWorker.addEventListener('message', handler);
            return function () {
                navigator.serviceWorker.removeEventListener('message', handler);
            };
        } : _b, _c = _options.sender, sender = _c === void 0 ? function (message) {
            var _a;
            var transfer = (_a = message.transfer) !== null && _a !== void 0 ? _a : [];
            delete message.transfer;
            worker.postMessage(message, transfer);
        } : _c, options = tslib_1.__rest(_options, ["worker", "useOnSafari", "listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return ServiceWorkerClientTransport;
}(transport.Transport));
exports.ServiceWorkerClientTransport = ServiceWorkerClientTransport;
var ServiceWorkerServiceTransport = /** @class */ (function (_super) {
    tslib_1.__extends(ServiceWorkerServiceTransport, _super);
    function ServiceWorkerServiceTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _this = this;
        var _a = _options.useOnSafari, useOnSafari = _a === void 0 ? DEFAULT_USE_ON_SAFARI : _a, _b = _options.listener, listener = _b === void 0 ? function (callback) {
            var handler = function (_a) {
                var data = _a.data, source = _a.source;
                data._clientId = source.id;
                callback(data);
            };
            self.addEventListener('message', handler);
            return function () { return self.removeEventListener('message', handler); };
        } : _b, _c = _options.sender, sender = _c === void 0 ? function (message) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var transfer, data, client_1, client;
            var _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        transfer = message.transfer || [];
                        delete message.transfer;
                        data = decode(message, useOnSafari);
                        if (!message._clientId) return [3 /*break*/, 2];
                        return [4 /*yield*/, self.clients.get(message._clientId)];
                    case 1:
                        client_1 = _b.sent();
                        if (!client_1) {
                            console.warn("The client \"".concat(message._clientId, "\" is closed."));
                            return [2 /*return*/];
                        }
                        delete message._clientId;
                        client_1.postMessage(data, transfer);
                        return [2 /*return*/];
                    case 2:
                        client = (_a = message._extra) === null || _a === void 0 ? void 0 : _a._client;
                        if (client) {
                            delete message._extra._client;
                            client.postMessage(data, transfer);
                            return [2 /*return*/];
                        }
                        self.clients
                            .matchAll()
                            .then(function (all) {
                            return all.map(function (client) { return client.postMessage(data, transfer); });
                        });
                        return [2 /*return*/];
                }
            });
        }); } : _c, options = tslib_1.__rest(_options, ["useOnSafari", "listener", "sender"]);
        _this = _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
        self.addEventListener('activate', function (event) {
            event.waitUntil(self.clients.claim());
        });
        return _this;
    }
    return ServiceWorkerServiceTransport;
}(transport.Transport));
exports.ServiceWorkerServiceTransport = ServiceWorkerServiceTransport;
exports.ServiceWorkerTransport = {
    Client: ServiceWorkerClientTransport,
    Service: ServiceWorkerServiceTransport,
};

});

var broadcastTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.BroadcastTransport = void 0;


var defaultChannel = '$$BroadcastChannel_Transport$$';
var BroadcastTransport = /** @class */ (function (_super) {
    tslib_1.__extends(BroadcastTransport, _super);
    function BroadcastTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _a = _options.channel, channel = _a === void 0 ? defaultChannel : _a, _b = _options.broadcastChannel, broadcastChannel = _b === void 0 ? new BroadcastChannel(channel) : _b, _c = _options.listener, listener = _c === void 0 ? function (callback) {
            var handler = function (_a) {
                var data = _a.data;
                callback(data);
            };
            broadcastChannel.addEventListener('message', handler);
            return function () {
                broadcastChannel.removeEventListener('message', handler);
            };
        } : _c, _d = _options.sender, sender = _d === void 0 ? function (message) { return broadcastChannel.postMessage(message); } : _d, options = tslib_1.__rest(_options, ["channel", "broadcastChannel", "listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return BroadcastTransport;
}(transport.Transport));
exports.BroadcastTransport = BroadcastTransport;

});

var electronTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElectronTransport = exports.ElectronRendererTransport = exports.ElectronMainTransport = void 0;


var defaultChannel = '$$Electron_Transport$$';
var ElectronMainTransport = /** @class */ (function (_super) {
    tslib_1.__extends(ElectronMainTransport, _super);
    function ElectronMainTransport(_options) {
        var ipcMain = _options.ipcMain, browserWindow = _options.browserWindow, _a = _options.channel, channel = _a === void 0 ? defaultChannel : _a, _b = _options.listener, listener = _b === void 0 ? function (callback) {
            var handler = function (_, data) {
                callback(data);
            };
            ipcMain.on(channel, handler);
            return function () {
                ipcMain.off(channel, handler);
            };
        } : _b, _c = _options.sender, sender = _c === void 0 ? function (message) { return browserWindow.webContents.send(channel, message); } : _c, options = tslib_1.__rest(_options, ["ipcMain", "browserWindow", "channel", "listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return ElectronMainTransport;
}(transport.Transport));
exports.ElectronMainTransport = ElectronMainTransport;
var ElectronRendererTransport = /** @class */ (function (_super) {
    tslib_1.__extends(ElectronRendererTransport, _super);
    function ElectronRendererTransport(_options) {
        var ipcRenderer = _options.ipcRenderer, _a = _options.channel, channel = _a === void 0 ? defaultChannel : _a, _b = _options.listener, listener = _b === void 0 ? function (callback) {
            var handler = function (_, data) {
                callback(data);
            };
            ipcRenderer.on(channel, handler);
            return function () {
                ipcRenderer.off(channel, handler);
            };
        } : _b, _c = _options.sender, sender = _c === void 0 ? function (message) { return ipcRenderer.send(channel, message); } : _c, options = tslib_1.__rest(_options, ["ipcRenderer", "channel", "listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return ElectronRendererTransport;
}(transport.Transport));
exports.ElectronRendererTransport = ElectronRendererTransport;
exports.ElectronTransport = {
    Main: ElectronMainTransport,
    Renderer: ElectronRendererTransport,
};

});

var browserExtensionsTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrowserExtensionsTransport = exports.BrowserExtensionsClientTransport = exports.BrowserExtensionsMainTransport = exports.BrowserExtensionsGenericTransport = void 0;



var transportName = '__DATA_TRANSPORT_BROWSER_EXTENSIONS__';
var BrowserExtensionsGenericTransport = /** @class */ (function (_super) {
    tslib_1.__extends(BrowserExtensionsGenericTransport, _super);
    function BrowserExtensionsGenericTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _a;
        var _b = _options.browser, browser = _b === void 0 ? (_a = commonjsGlobal.browser) !== null && _a !== void 0 ? _a : commonjsGlobal.chrome : _b, _c = _options.listener, listener = _c === void 0 ? function (callback) {
            this[constant.callbackKey] = callback;
            var handler = function (data, sender, sendResponse) {
                data._sendResponse = sendResponse;
                callback(data);
            };
            browser.runtime.onMessage.addListener(handler);
            return function () {
                browser.runtime.onMessage.removeListener(handler);
            };
        } : _c, _d = _options.sender, sender = _d === void 0 ? function (message) {
            if (message._sendResponse) {
                var sendResponse = message._sendResponse;
                delete message._sendResponse;
                sendResponse(message);
            }
            else {
                // @ts-ignore
                browser.runtime.sendMessage(message, {}, this[constant.callbackKey]);
            }
        } : _d, options = tslib_1.__rest(_options, ["browser", "listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return BrowserExtensionsGenericTransport;
}(transport.Transport));
exports.BrowserExtensionsGenericTransport = BrowserExtensionsGenericTransport;
var connectEventName = 'sharedworker-connect';
var BrowserExtensionsMainTransport = /** @class */ (function (_super) {
    tslib_1.__extends(BrowserExtensionsMainTransport, _super);
    function BrowserExtensionsMainTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _this = this;
        var _a;
        var _b = _options.browser, browser = _b === void 0 ? (_a = commonjsGlobal.browser) !== null && _a !== void 0 ? _a : commonjsGlobal.chrome : _b, _c = _options.listener, listener = _c === void 0 ? function (callback) {
            var _this = this;
            this[constant.callbackKey] = callback;
            return function () {
                _this.ports.forEach(function (port) {
                    port.disconnect();
                });
            };
        } : _c, _d = _options.sender, sender = _d === void 0 ? function (message) {
            var _a;
            var port = (_a = message._extra) === null || _a === void 0 ? void 0 : _a._port;
            if (port) {
                delete message._port;
                port.postMessage(message);
            }
            else if (message.type === 'response' &&
                // @ts-ignore
                this.ports.has(message.requestId)) {
                // @ts-ignore
                var port_1 = this.ports.get(message.requestId);
                port_1.postMessage(message);
            }
            else {
                this.ports.forEach(function (port) {
                    port.postMessage(message);
                });
            }
        } : _d, options = tslib_1.__rest(_options, ["browser", "listener", "sender"]);
        _this = _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
        _this.ports = new Map();
        _this._onConnectCallback = new Set();
        _this._onDisconnectCallback = new Set();
        browser.runtime.onConnect.addListener(function (port) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var handler_1, id_1;
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(port.name === transportName)) return [3 /*break*/, 2];
                        handler_1 = function (data) {
                            var _a;
                            data._extra = (_a = data._extra) !== null && _a !== void 0 ? _a : {};
                            data._extra._port = port;
                            _this[constant.callbackKey](data);
                        };
                        port.onMessage.addListener(handler_1);
                        port.onDisconnect.addListener(function () {
                            port.onMessage.removeListener(handler_1);
                            _this.ports.forEach(function (_port, id) {
                                if (_port === port) {
                                    _this.ports.delete(id);
                                }
                            });
                        });
                        return [4 /*yield*/, this.emit({
                                // @ts-ignore
                                name: connectEventName,
                                _extra: { _port: port },
                            })];
                    case 1:
                        id_1 = _a.sent();
                        this.ports.set(id_1, port);
                        this._onConnectCallback.forEach(function (callback) {
                            callback(id_1);
                        });
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        }); });
        return _this;
    }
    BrowserExtensionsMainTransport.prototype.onConnect = function (callback) {
        var _this = this;
        this._onConnectCallback.add(callback);
        return function () {
            _this._onConnectCallback.delete(callback);
        };
    };
    BrowserExtensionsMainTransport.prototype.onDisconnect = function (callback) {
        var _this = this;
        this._onDisconnectCallback.add(callback);
        return function () {
            _this._onDisconnectCallback.delete(callback);
        };
    };
    return BrowserExtensionsMainTransport;
}(transport.Transport));
exports.BrowserExtensionsMainTransport = BrowserExtensionsMainTransport;
var BrowserExtensionsClientTransport = /** @class */ (function (_super) {
    tslib_1.__extends(BrowserExtensionsClientTransport, _super);
    function BrowserExtensionsClientTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _this = this;
        var _a;
        var _b = _options.browser, browser = _b === void 0 ? (_a = commonjsGlobal.browser) !== null && _a !== void 0 ? _a : commonjsGlobal.chrome : _b, _c = _options.port, port = _c === void 0 ? browser.runtime.connect({ name: transportName }) : _c, _d = _options.listener, listener = _d === void 0 ? function (callback) {
            var handler = function (options) {
                callback(options);
            };
            port.onMessage.addListener(handler);
            return function () {
                port.onMessage.removeListener(handler);
            };
        } : _d, _e = _options.sender, sender = _e === void 0 ? function (message) {
            port.postMessage(message);
        } : _e, options = tslib_1.__rest(_options, ["browser", "port", "listener", "sender"]);
        _this = _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
        _this._onConnectCallback = new Set();
        // @ts-ignore
        _this.listen(connectEventName, function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                Promise.resolve().then(function () {
                    _this._onConnectCallback.forEach(function (callback) {
                        callback();
                    });
                });
                return [2 /*return*/, this.id];
            });
        }); });
        return _this;
    }
    BrowserExtensionsClientTransport.prototype.onConnect = function (callback) {
        var _this = this;
        this._onConnectCallback.add(callback);
        return function () {
            _this._onConnectCallback.delete(callback);
        };
    };
    return BrowserExtensionsClientTransport;
}(transport.Transport));
exports.BrowserExtensionsClientTransport = BrowserExtensionsClientTransport;
exports.BrowserExtensionsTransport = {
    Main: BrowserExtensionsMainTransport,
    Client: BrowserExtensionsClientTransport,
};

});

var webRTCTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebRTCTransport = void 0;


var MAX_CHUNK_SIZE = 1024 * 60;
var BUFFER_FULL_THRESHOLD = 1024 * 64;
var EXPIRED_TIME = 1000 * 60;
var WebRTCTransport = /** @class */ (function (_super) {
    tslib_1.__extends(WebRTCTransport, _super);
    function WebRTCTransport(_options) {
        var _this = this;
        var peer = _options.peer, _a = _options.listener, listener = _a === void 0 ? function (callback) {
            var handler = function (data) {
                var e_1, _a;
                var _b;
                var message = JSON.parse(data);
                var key = Object.prototype.hasOwnProperty.call(message, 'request')
                    ? 'request'
                    : 'response';
                var buffer = (_b = _this.receiveBuffer.get(message.__DATA_TRANSPORT_UUID__)) !== null && _b !== void 0 ? _b : {
                    data: [],
                    timestamp: Date.now(),
                };
                _this.receiveBuffer.set(message.__DATA_TRANSPORT_UUID__, buffer);
                buffer.data[message.chunkId] = message[key];
                buffer.data.length = message.length;
                buffer.timestamp = Date.now();
                var isComplete = buffer.data.filter(function (item) { return item; }).length === message.length;
                if (isComplete) {
                    var data_1 = JSON.parse(buffer.data.join(''));
                    message[key] = key === 'request' ? data_1 : data_1[0];
                    delete message.length;
                    callback(message);
                    _this.receiveBuffer.delete(message.__DATA_TRANSPORT_UUID__);
                    try {
                        for (var _c = tslib_1.__values(_this.receiveBuffer), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var _e = tslib_1.__read(_d.value, 2), id = _e[0], item = _e[1];
                            if (Date.now() - item.timestamp > EXPIRED_TIME) {
                                _this.receiveBuffer.delete(id);
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }
            };
            peer.on('data', handler);
            return function () {
                peer.off('data', handler);
            };
        } : _a, _b = _options.sender, sender = _b === void 0 ? function (message) {
            var _a;
            var key = Object.prototype.hasOwnProperty.call(message, 'request')
                ? 'request'
                : 'response';
            message[key] = JSON.stringify(key === 'request'
                ? message.request
                : typeof message.response !== 'undefined'
                    ? [message.response]
                    : []);
            var chunkId = 0;
            var allChunksSize = Math.ceil(message[key].length / MAX_CHUNK_SIZE);
            while (message[key].length > 0) {
                var data = tslib_1.__assign(tslib_1.__assign({}, message), (_a = {}, _a[key] = message[key].slice(0, MAX_CHUNK_SIZE), _a.chunkId = chunkId, _a.length = allChunksSize, _a));
                peer.send(JSON.stringify(data));
                message[key] = message[key].slice(MAX_CHUNK_SIZE);
                chunkId += 1;
            }
        } : _b, options = tslib_1.__rest(_options, ["peer", "listener", "sender"]);
        _this = _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
        _this.receiveBuffer = new Map();
        if (peer) {
            var webRTCPaused_1 = false;
            var webRTCMessageQueue_1 = [];
            var peerSend_1 = peer.send.bind(peer);
            var sendMessageQueued_1 = function () {
                webRTCPaused_1 = false;
                var message = webRTCMessageQueue_1.shift();
                var _loop_1 = function () {
                    if (peer._channel.bufferedAmount &&
                        peer._channel.bufferedAmount > BUFFER_FULL_THRESHOLD) {
                        webRTCPaused_1 = true;
                        webRTCMessageQueue_1.unshift(message);
                        var listener_1 = function () {
                            peer._channel.removeEventListener('bufferedamountlow', listener_1);
                            sendMessageQueued_1();
                        };
                        peer._channel.addEventListener('bufferedamountlow', listener_1);
                        return { value: void 0 };
                    }
                    try {
                        peerSend_1(message);
                        message = webRTCMessageQueue_1.shift();
                    }
                    catch (error) {
                        throw new Error("Error send message to peer: ".concat(error.message));
                    }
                };
                while (message) {
                    var state_1 = _loop_1();
                    if (typeof state_1 === "object")
                        return state_1.value;
                }
            };
            peer.send = function (chunk) {
                webRTCMessageQueue_1.push(chunk);
                if (webRTCPaused_1) {
                    return;
                }
                sendMessageQueued_1();
            };
        }
        return _this;
    }
    return WebRTCTransport;
}(transport.Transport));
exports.WebRTCTransport = WebRTCTransport;

});

var messageTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageTransport = void 0;


var MessageTransport = /** @class */ (function (_super) {
    tslib_1.__extends(MessageTransport, _super);
    function MessageTransport(_options) {
        var _a = _options.targetOrigin, targetOrigin = _a === void 0 ? '*' : _a, _b = _options.listener, listener = _b === void 0 ? function (callback) {
            var handler = function (_a) {
                var data = _a.data;
                return callback(data);
            };
            window.addEventListener('message', handler);
            return function () {
                window.removeEventListener('message', handler);
            };
        } : _b, _c = _options.sender, sender = _c === void 0 ? function (message) {
            window.postMessage(message, targetOrigin);
        } : _c, options = tslib_1.__rest(_options, ["targetOrigin", "listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return MessageTransport;
}(transport.Transport));
exports.MessageTransport = MessageTransport;

});

var processTransport = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcessTransport = exports.ChildProcessTransport = exports.MainProcessTransport = void 0;


var MainProcessTransport = /** @class */ (function (_super) {
    tslib_1.__extends(MainProcessTransport, _super);
    function MainProcessTransport(_options) {
        var child = _options.child, _a = _options.listener, listener = _a === void 0 ? function (callback) {
            var handler = function (data) {
                callback(data);
            };
            child.on('message', handler);
            return function () {
                child.off('message', handler);
            };
        } : _a, _b = _options.sender, sender = _b === void 0 ? function (message) {
            child.send(message);
        } : _b, options = tslib_1.__rest(_options, ["child", "listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return MainProcessTransport;
}(transport.Transport));
exports.MainProcessTransport = MainProcessTransport;
var ChildProcessTransport = /** @class */ (function (_super) {
    tslib_1.__extends(ChildProcessTransport, _super);
    function ChildProcessTransport(_options) {
        if (_options === void 0) { _options = {}; }
        var _a = _options.listener, listener = _a === void 0 ? function (callback) {
            var handler = function (data) {
                callback(data);
            };
            process.on('message', handler);
            return function () {
                process.off('message', handler);
            };
        } : _a, _b = _options.sender, sender = _b === void 0 ? function (message) {
            // @ts-ignore
            process.send(message);
        } : _b, options = tslib_1.__rest(_options, ["listener", "sender"]);
        return _super.call(this, tslib_1.__assign(tslib_1.__assign({}, options), { listener: listener, sender: sender })) || this;
    }
    return ChildProcessTransport;
}(transport.Transport));
exports.ChildProcessTransport = ChildProcessTransport;
exports.ProcessTransport = {
    Main: MainProcessTransport,
    Child: ChildProcessTransport,
};

});

var transports = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });

tslib_1.__exportStar(iframeTransport, exports);
tslib_1.__exportStar(workerTransport, exports);
tslib_1.__exportStar(sharedWorkerTransport, exports);
tslib_1.__exportStar(serviceWorkerTransport, exports);
tslib_1.__exportStar(broadcastTransport, exports);
tslib_1.__exportStar(electronTransport, exports);
tslib_1.__exportStar(browserExtensionsTransport, exports);
tslib_1.__exportStar(webRTCTransport, exports);
tslib_1.__exportStar(messageTransport, exports);
tslib_1.__exportStar(processTransport, exports);

});

var createTransport_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTransport = void 0;


var TransportMap = {
    Base: transport.Transport,
    MessageTransport: transports.MessageTransport,
    IFrameMain: transports.IFrameTransport.Main,
    IFrameInternal: transports.IFrameTransport.IFrame,
    BrowserExtensions: transports.BrowserExtensionsGenericTransport,
    BrowserExtensionsMain: transports.BrowserExtensionsTransport.Main,
    BrowserExtensionsClient: transports.BrowserExtensionsTransport.Client,
    ElectronMain: transports.ElectronTransport.Main,
    ElectronRenderer: transports.ElectronTransport.Renderer,
    ServiceWorkerClient: transports.ServiceWorkerTransport.Client,
    ServiceWorkerService: transports.ServiceWorkerTransport.Service,
    WorkerMain: transports.WorkerTransport.Main,
    WorkerInternal: transports.WorkerTransport.Worker,
    WebRTC: transports.WebRTCTransport,
    Broadcast: transports.BroadcastTransport,
    SharedWorkerClient: transports.SharedWorkerTransport.Client,
    SharedWorkerInternal: transports.SharedWorkerTransport.Worker,
    MainProcess: transports.ProcessTransport.Main,
    ChildProcess: transports.ProcessTransport.Child,
};
/**
 * Create a transport instance.
 *
 * @param name transport type name
 * @param options transport options
 *
 * @returns Return a transport instance.
 */
var createTransport = function (name, options) {
    return new TransportMap[name](options);
};
exports.createTransport = createTransport;

});

var mockPorts_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockPorts = void 0;

/**
 * Mock ports for testing
 */
var mockPorts = function () {
    var emitter = new Set();
    var mainCallback = null;
    return {
        main: {
            listener: function (callback) {
                mainCallback = callback;
                return function () {
                    mainCallback = null;
                };
            },
            sender: function (message) {
                var e_1, _a;
                try {
                    for (var emitter_1 = tslib_1.__values(emitter), emitter_1_1 = emitter_1.next(); !emitter_1_1.done; emitter_1_1 = emitter_1.next()) {
                        var emit = emitter_1_1.value;
                        emit(JSON.parse(JSON.stringify(message)));
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (emitter_1_1 && !emitter_1_1.done && (_a = emitter_1.return)) _a.call(emitter_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            },
        },
        create: function () { return ({
            listener: function (callback) {
                emitter.add(callback);
                return function () {
                    emitter.delete(callback);
                };
            },
            sender: function (message) {
                mainCallback === null || mainCallback === void 0 ? void 0 : mainCallback(JSON.parse(JSON.stringify(message)));
            },
        }); },
    };
};
exports.mockPorts = mockPorts;

});

var merge_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.merge = void 0;



/**
 * Merge multiple transports into one transport
 */
var merge = function (first, seconds) {
    var _args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        _args[_i - 2] = arguments[_i];
    }
    var args = tslib_1.__spreadArray([first, seconds], tslib_1.__read(_args), false);
    if (typeof first === 'undefined' || typeof seconds === 'undefined') {
        throw new Error("Only more than one transports can be merged.");
    }
    return (0, createTransport_1.createTransport)('Base', {
        listener: function (callback) {
            var handler = function (data) {
                callback(data);
            };
            var disposers = args.map(function (transport) {
                return transport[constant.listenerKey](handler);
            });
            return function () {
                disposers.forEach(function (dispose) { return dispose && dispose(); });
            };
        },
        sender: function (message) {
            args.forEach(function (transport) {
                transport[constant.senderKey](message);
            });
        },
    });
};
exports.merge = merge;

});

var _interface = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });


});

var dist = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.verboseKey = exports.logKey = exports.listenKey = exports.senderKey = exports.listenerKey = void 0;


Object.defineProperty(exports, "listenerKey", { enumerable: true, get: function () { return constant.listenerKey; } });
Object.defineProperty(exports, "senderKey", { enumerable: true, get: function () { return constant.senderKey; } });
Object.defineProperty(exports, "listenKey", { enumerable: true, get: function () { return constant.listenKey; } });
Object.defineProperty(exports, "logKey", { enumerable: true, get: function () { return constant.logKey; } });
Object.defineProperty(exports, "verboseKey", { enumerable: true, get: function () { return constant.verboseKey; } });
tslib_1.__exportStar(decorators, exports);
tslib_1.__exportStar(transport, exports);
tslib_1.__exportStar(createTransport_1, exports);
tslib_1.__exportStar(transports, exports);
tslib_1.__exportStar(mockPorts_1, exports);
tslib_1.__exportStar(merge_1, exports);
tslib_1.__exportStar(_interface, exports);

});

var index = /*@__PURE__*/getDefaultExportFromCjs(dist);

module.exports = index;
//# sourceMappingURL=index.cjs.development.js.map
