/// <reference types="node" />
import type { ChildProcess } from 'child_process';
import type { BaseInteraction, TransportOptions } from '../interface';
import { Transport } from '../transport';
export interface MainProcessTransportOptions extends Partial<TransportOptions> {
    child: ChildProcess;
}
export declare class MainProcessTransport<T extends BaseInteraction = any> extends Transport<T> {
    constructor(_options: MainProcessTransportOptions);
}
export interface ChildProcessTransportOptions extends Partial<TransportOptions> {
}
export declare class ChildProcessTransport<T extends BaseInteraction = any> extends Transport<T> {
    constructor(_options?: ChildProcessTransportOptions);
}
export declare const ProcessTransport: {
    Main: typeof MainProcessTransport;
    Child: typeof ChildProcessTransport;
};
//# sourceMappingURL=processTransport.d.ts.map