import type { TransportOptions, TransferableWorker, BaseInteraction } from '../interface';
import { Transport } from '../transport';
export interface WorkerMainTransportOptions extends Partial<TransportOptions<TransferableWorker>> {
    /**
     * Pass web worker using data transport.
     */
    worker: Worker;
}
export interface WorkerInternalTransportOptions extends Partial<TransportOptions<TransferableWorker>> {
}
export declare abstract class WorkerMainTransport<T extends BaseInteraction = any> extends Transport<T> {
    constructor(_options: WorkerMainTransportOptions);
}
export declare abstract class WorkerInternalTransport<T extends BaseInteraction = any> extends Transport<T> {
    constructor(_options?: WorkerInternalTransportOptions);
}
export declare const WorkerTransport: {
    Main: typeof WorkerMainTransport;
    Worker: typeof WorkerInternalTransport;
};
//# sourceMappingURL=workerTransport.d.ts.map